/*==================================================================
                     	+---------------+
 			|   hlsinit.h   |
                     	+---------------+

THE PLACE WHERE THE VARIABLES ARE REALLY DECLARED. DON'T USE !


 First official version. All 0.x versions are outdated !
 New: sextupole_record replaced with magnet_record. N_PM changed
 to N_SRPM.
 Beta 1.0				(Mark Plesko 28.10.92)
 
 A matrix_2D unit matrix is defined.
 Beta 1.1				(M.P. 6.11.92)
 
 The matrix_2D has been changed from 2x2 to 3x3 in dimension.
 Beta 1.2				(M.P. 15.12.92)

 The global variable model_tune[2] is added.  pAccBPM_AvgT and pAcc_BPM[2]
 added. pAccTL and pAccSR in energy changed to pAcc[2]
 Beta 1.3				(M.P. 10.2.93)
 
 The access pointer for the DCCT added (pAccDCCT) and pAcc_BPM[2]
 changed to pAccBPM_SR (because there is no way anymore to read all
 TL BPMs). pAccBPM_AvgT is deleted, because the same information is
 contained in pAccBPM_SR. Note: they are used in the bpm service.
 V 1.4					(M.P. 2.8.93)

 The energy_record gets another variable: readback. This corresponds
 to the energy determined from the read current, while E now corresponds
 to the energy calculated from the PS set values.
 2.0					(M.P. 10.11.93)
 
 Added pAccInfo, the access record of the beam info sever.
 2.1					(M.P. 21.11.95)
 ==================================================================*/

/* first include HLS type definitions */

#include "hlsdef.h"


/* define arrays of pointers to data structures */

general_record		*ge[AL_ge] ;
family_record		*fa[AL_fa] ;
drift_record		*dr[AL_dr] ;
magnet_record		*be[AL_be] ;
magnet_record		*qu[AL_qu] ;
ID_record		      *id[AL_id] ;
septum_record		*sp[AL_sp] ;
magnet_record		*se[AL_se] ;
corrector_record	      *co[AL_co] ;
kicker_record		*ki[AL_ki] ;
scraper_record		*sc[AL_sc] ;
monitor_record		*fs[AL_fs] ;
monitor_record		*pr[AL_pr] ;
monitor_record		*po[AL_po] ;
CM_record		      *cm[AL_cm] ;
cavity_record		*cav[AL_cav] ;
tag_record		      *ta[AL_ta] ;
corrector_record		*chi[AL_chi] ;


/* define variables used for program flow control */

int		N_general=0;	/* the actual number of all elements */
int		N_family=0;		/* the actual number of magnet families */
int		N_drift=0;		/* the actual number of drift elements */
int		N_bend=0;		/* the actual number of bend magnets */
int		N_quad=0;	      /* the actual number of quads */
int		N_ID=0;		/* the actual number of IDs */
int		N_septum=0;	      /* the actual number of septa */
int		N_sextupole=0;	/* the actual number of sextupoles */
int		N_corrector=0;	/* the actual number of correctors */
int		N_kicker=0;	      /* the actual number of kickers */
int		N_scraper=0;	/* the actual number of scrapers */
int		N_FS=0;		/* the actual number of Fl.Screens */
int		N_SRPM=0;	      /* the actual number of Profile Mon. */
int		N_BPM=0;	      /* the actual number of monitors */
int		N_CM=0;		/* the actual number of Curr.Mon. */
int		N_cavity=0;		/* the actual number of cavities */
int		N_tag=0;	      /* the actual number of tags */
int		N_chicane=0;	/* the actual number of chicanes */


/* the declaration of variables used for optics calcuations */

int		N_section=0;		/* the number of sections */
double		section_length=0.0;	/* the length of one section */
double		total_length=0.0;	/* the length of the whole structure */
double		model_tune[2]={0,0};	/* the tune of the whole structure */


/* the information how to get the energy */

struct {
	access_record	*pAcc[2] ;
	double		readback, E ;
} energy ;


/* the access pointers to special data (read with input_special in
   the routine input_close_files) */

access_record	*pAccBPM_SR, *pAccTune, *pAccDCCT, *pAccRF, *pAccInfo ;


/* the unit matrix in both planes - it is pointed to by ge[]->transfer
   of thin elements. It may be used to initialize other matrices (in
   ANSI C structs may be assigned directly). */
   
matrix_2D	unit_matrix = {1,0,0, 0,1,0, 0,0,1, 1,0,0, 0,1,0, 0,0,1} ;


/*==================================================================
  ************************ end of hlsinit.h **********************
==================================================================*/
