#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <time.h>

#include "hlsvar.h"
#include "hlsrpc.h"

host_record     HostZigZag9 ; 
access_record   AccZigZag9 ; 

               
int	get_zigzag_current ( i, readback, raw_value ) 

int             i ;
double		*readback ;
double		*raw_value ;

{
  RPC_list	list ;

    /* set input parameter list to do_rpc */
  list.lpc.family = "PSZGZG" ;
  list.lpc.member = "S9" ;

  /* read first the readback */
  list.lpc.action = "CURR" ;
  list.lpc.datum = readback ;

  if ( 0 > do_rpc ( &HostZigZag9, service_lpc, "RR", &list ) ) return ( -1 ) ;

    printf ( " \n read readback %8.3lf \n",*readback);

  /* now read the setting */
  list.lpc.action = "CURSET" ;
  list.lpc.datum = raw_value ;
  if ( 0 > do_rpc (&HostZigZag9 , service_lpc, "RR", &list ) ) return ( -2 ) ;

    printf ( " \n read raw_value %8.3lf \n",*raw_value);
 
  /* crude check: give error if reading and setting differ by more than 1 Amp*/
  if ( fabs ( *readback - *raw_value ) > 1.0 ) 
  {
/*    printf ( "#Warning: read and set values differ for %s_%s\n",
    family, member ) ;
*/
    return ( -3 ) ;
  }
  else return ( 0 ) ;
}

int	read_tags_from_field ()
{
  int i, res ;

  res = 0 ; 

  strcpy ( HostZigZag9.host, "ecida9" ) ;
  HostZigZag9.port = 10000 ;
  HostZigZag9.sid = -1 ;

    AccZigZag9.pHost = &HostZigZag9 ;

  for (i=0;i<N_tag;i++)
   {
    res = get_zigzag_current (i, &ta[i]->readback, 
    					&ta[i]->raw_value ) ; 
   }
  return ( res ) ;
}


int f2s_tags () 
{
  int		i, err=0 ;

  for (i=0;i<N_tag;i++)
    {
    err += field_to_strength_zigzag (i, ta[i]->raw_value, 
    					       	&ta[i]->converted_value ) ;
    }

  return ( err ) ;
} 

int field_to_strength_zigzag (i,value, strength) 
int                     i ;
double			value ;
double			*strength ;

{
  double cc = -3.0626 ;
  if ( energy.E == 0 ) { *strength=0.0; return ( -2 ) ; } 

 
  *strength = fabs(value) * cc ;
  *strength *= 0.29979245 / energy.E ;
  if ( value < 0.0 ) *strength = - *strength ;

  return ( 0 ) ;
} 
